#<profile4xi profile = "31"/>
#<program4xi program = "add2index4gimbal.py">
#<abstract4xi abstract = "fetches sending defined programs from scope4xi folders"/>
#<refer4xi reference = "Studio4Xi"/>
#<note4xi note = "output is automatically deleted and written again by opening to write"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
#<use4xi usage = "
#
# 1) go to Studio4Xi in commmand mode
#     > go3studio4fb    <-- Python 3 version of Studio4Xi in Fastblack workstation (fb)
#     > go3studio4riika <-- Python 3 version of Studio4Xi in Riika
#     nb: you could use the same go2studio4xi-command in all workstations just defining root! 
#
# 2) edit version4xi.py
#
#     ===========================================================================================================                         
#     add2index4gimbal.py 
#     ===========================================================================================================                          
#     'folder2add4index':      # 'E:///pc4xi//gimbal//',
#
# 3) modify behaviour, if necessary
#    a) ack2index = True
#    b) ack2names = False
#
# 4) > add2index4gimbal
#
# 5) view what you got
#      trace \temp\add2index4gimbal.txt
#      
# 
# Note: Pipe4Xi and Queue4Xi were activated for future use if more performance is required
#"
#/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'add2index4gimbal' ]
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os,sys,string
import time4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Studio4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
from version4xi import VersionKB4Xi 
from version4xi import ROOT4XI
#"
#/>
# -------------------------------------------------------------------------------------------------
# Multiprocessing4xi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from actor2a4xi import Actor2a4Xi                                                                                  
from actor2b4xi import Actor2b4Xi                                                                                   
from actor2c4xi import Actor2c4Xi
from actor2d4xi import Actor2d4Xi
from actor2e4xi import Actor2e4Xi
from actor2f4xi import Actor2f4Xi
from actor2g4xi import Actor2g4Xi
from actor2h4xi import Actor2h4Xi
from actor2i4xi import Actor2i4Xi
from actor2j4xi import Actor2j4Xi
from actor2k4xi import Actor2k4Xi
from actor2l4xi import Actor2l4Xi
from actor2m4xi import Actor2m4Xi
from actor2n4xi import Actor2n4Xi
from actor2o4xi import Actor2o4Xi
from actor2p4xi import Actor2p4Xi
from actor2q4xi import Actor2q4Xi
from actor2r4xi import Actor2r4Xi
from actor2s4xi import Actor2s4Xi
from actor2t4xi import Actor2t4Xi
from actor2u4xi import Actor2u4Xi
from actor2v4xi import Actor2v4Xi
from actor2w4xi import Actor2w4Xi
from actor2x4xi import Actor2x4Xi
from actor2y4xi import Actor2y4Xi
from actor2z4xi import Actor2z4Xi
from actor2_4xi import Actor2_4Xi
from pickle4xi import pickle4xi                                                                                   
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi 
from pipe4xi import Pipe4Xi   
from print4xi import print4xi
from print4xi import Print4Xi 
from process4xi import Process4Xi
from queue4xi import Queue4Xi
from time4xi import time4xi

from xml_trace_sense4xi import xml_trace_sense4xi                                                                   
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# Globals                            
# -------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global ack2message4index
global AlphaKB4Xi
global keys2AlphaKB4Xi
global key2AlphaKB4Xi

global IndexKB4Xi
global keys2IndexKB4Xi
global key2IndexKB4Xi

global LevelOneKB4Xi
global keys2LevelOneKB4Xi
global key2LevelOneKB4Xi

global LevelTwoKB4Xi
global keys2LevelTwoKB4Xi
global key2LevelTwoKB4Xi

global LevelThreeKB4Xi
global keys2LevelThreeKB4Xi
global key2LevelThreeKB4Xi

global LevelFourKB4Xi
global keys2LevelFourKB4Xi
global key2LevelFourKB4Xi

global LevelFiveKB4Xi
global keys2LevelFiveKB4Xi
global key2LevelFiveKB4Xi

global LevelSixKB4Xi
global keys2LevelSixKB4Xi
global key2LevelSixKB4Xi

global LevelSevenKB4Xi
global keys2LevelSevenKB4Xi
global key2LevelSevenKB4Xi

global LevelEightKB4Xi
global keys2LevelEightKB4Xi
global key2LevelEightKB4Xi

global path2temp4source  
global path2read4xi                          # path for input files
global path2temp4xi                          # path for output files
global PickleKB4Xi

global NameKB4Xi
global keys2NameKB4Xi
global key2NameKB4Xi

global t2xi 
global trace_object_count
#"
#"/>

# -------------------------------------------------------------------------------------------------
# Settings 
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2index = True
ack2names = False

ack2message4index = False
AlphaKB4Xi      = {}
AlphaKB4Xi['a'] = {}
AlphaKB4Xi['b'] = {}
AlphaKB4Xi['c'] = {}
AlphaKB4Xi['d'] = {}
AlphaKB4Xi['e'] = {}
AlphaKB4Xi['f'] = {}
AlphaKB4Xi['g'] = {}
AlphaKB4Xi['h'] = {}
AlphaKB4Xi['i'] = {}
AlphaKB4Xi['j'] = {}
AlphaKB4Xi['k'] = {}
AlphaKB4Xi['l'] = {}
AlphaKB4Xi['m'] = {}
AlphaKB4Xi['n'] = {}
AlphaKB4Xi['o'] = {}
AlphaKB4Xi['p'] = {}
AlphaKB4Xi['q'] = {}
AlphaKB4Xi['r'] = {}
AlphaKB4Xi['s'] = {}
AlphaKB4Xi['t'] = {}
AlphaKB4Xi['u'] = {}
AlphaKB4Xi['v'] = {}
AlphaKB4Xi['w'] = {}
AlphaKB4Xi['x'] = {}
AlphaKB4Xi['y'] = {}
AlphaKB4Xi['z'] = {} 
keys2AlphaKB4Xi = AlphaKB4Xi.keys()
key2AlphaKB4Xi  = 0

IndexKB4Xi = {}
IndexKB4Xi[0] = {}
IndexKB4Xi[1] = {}
IndexKB4Xi[2] = {}
IndexKB4Xi[3] = {}
IndexKB4Xi[4] = {}
IndexKB4Xi[5] = {}
IndexKB4Xi[6] = {}
IndexKB4Xi[7] = {}
IndexKB4Xi[8] = {}
keys2IndexKB4Xi = IndexKB4Xi.keys()
key2IndexKB4Xi  = 0        

LevelOneKB4Xi = {}
keys2LevelOneKB4Xi = LevelOneKB4Xi.keys()
key2LevelOneKB4Xi  = 0

LevelTwoKB4Xi = {}
keys2LevelTwoKB4Xi = LevelTwoKB4Xi.keys()
key2LevelTwoKB4Xi  = 0

LevelThreeKB4Xi = {}
keys2LevelThreeKB4Xi = LevelThreeKB4Xi.keys()
key2LevelThreeKB4Xi  = 0

LevelFourKB4Xi = {}
keys2LevelFourKB4Xi = LevelFourKB4Xi.keys()
key2LevelFourKB4Xi  = 0

LevelFiveKB4Xi = {}
keys2LevelFiveKB4Xi = LevelFiveKB4Xi.keys()
key2LevelFiveKB4Xi  = 0

LevelSixKB4Xi = {}
keys2LevelSixKB4Xi = LevelSixKB4Xi.keys()
key2LevelSixKB4Xi  = 0

LevelSevenKB4Xi = {}
keys2LevelSevenKB4Xi = LevelSevenKB4Xi.keys()
key2LevelSevenKB4Xi  = 0

LevelEightKB4Xi = {}
keys2LevelEightKB4Xi = LevelEightKB4Xi.keys()
key2LevelEightKB4Xi  = 0    

NameKB4Xi = {}
keys2NameKB4Xi = NameKB4Xi.keys()
key2NameKB4Xi  = 0

path2read4xi  = VersionKB4Xi['folder2add4index']
path2temp4xi  = VersionKB4Xi['folder2add4index']

PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 

#"
#"/>

# -------------------------------------------------------------------------------------------------
#<define4xi definition = "

#"
#/>


# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4fecth" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4fecth():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 00A/33) OF SET2TRACE4FECTH - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 00B/33) OF SET2TRACE4FECTH - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 002A/33) OF SET2TRACE4FECTH - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 0033/33) OF SET2TRACE4FECTH - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4fetch" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4fetch():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 001A/33) of DENY2TRACE4FECTH: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 001B/33) OF DENY2TRACE4FECTH - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 001C/33) OF DENY2TRACE4FECTH - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 001D/33) OF DENY2TRACE4FECTH - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 001E/33) OF DENY2TRACE4FECTH - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEROOT4XI PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 001F/33) OF DENY2TRACE4FECTH - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 001Z/33) OF DENY2TRACE4FECTH *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 001G/33) OF DENY2TRACE4FECTH - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 002F/33) OF DENY2TRACE4FECTH - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 0033/33) OF SET2TRACE4FECTH - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 001A/33) OF TAILOR2TRACE4FECTH - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
         'Pipe4Xi': 'NACK4TRACE',
         'Queue4Xi': 'NACK4TRACE',         
         'Process4Xi': 'NACK4TRACE',
         'add2index4gimbal': 'NACK4TRACE'
        }                             
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # Pipe4Xi, Process4Xi, Queue4Xi, add2index4gimbal

    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    #

    
     
#</function4xi>             
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print-trace4xi" usage = "
# print XML trace
#"> 
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(t2xi):

    class2print  = "add2index4gimbal"
    method2print = "add2index4gimbal" 
        
    message2print = "{passed" + "; t2xi-passed-to-print-trace4xi: " + str(t2xi) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)   
    #    

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': '..//..//..//..//web//xml//sense-add2index.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/studio4xi/owl/studio4xi.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/web/lib/owl/studio4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing add2index4gimbal.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">add2index4gimbal sensed.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..//..//..//..//web//xml//reason-add2index.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/studio4xi/owl/studio4xi.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/web/lib/owl/studio4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for add2index4gimbal.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations with context.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..//..//..//..//web//xml//ace-add2index.xml',
     'name_space4xi': '   xmlns="https://www.yourdragonxi.org/studio4xi/owl/studio4xi.owl#"\n',
     'xml_base4xi': '   xml:base="https://www.yourdragonxi.org/web/lib/owl/studio4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Studio4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for add2index4gimbal.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values of add2index4gimbal.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
       

# =================================================================================================
#<class4xi class = "DirectoryWalker" base = "None" child = "None" synopsis = "a forward iterator that traverses a directory tree" usage = "
#   to review all tests"
#>
# =================================================================================================
class DirectoryWalker:

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init" usage = "initializes DirectoryWalker"> 
    # ---------------------------------------------------------------------------------------------
    def __init__(self, directory):
        self.stack = [directory]
        self.files = []
        self.index = 0
        
    #</methodize4xi>
            
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "getitem" usage = "getting item"> 
    # ---------------------------------------------------------------------------------------------
    def __getitem__(self, index):
        while 1:
            # ------------------------------------------------------------------------------------- 
            #
            # -------------------------------------------------------------------------------------          
            try:
                # --------------------------------------------------------------------------------- 
                #
                # ---------------------------------------------------------------------------------             
                file = self.files[self.index]
                self.index = self.index + 1
            except IndexError:
                # --------------------------------------------------------------------------------- 
                # pop next directory from stack
                # ---------------------------------------------------------------------------------             
                self.directory = self.stack.pop()
                self.files = os.listdir(self.directory)
                self.index = 0
            else:
                # --------------------------------------------------------------------------------- 
                # got a filename
                # ---------------------------------------------------------------------------------             
                fullname = os.path.join(self.directory, file)
                if os.path.isdir(fullname) and not os.path.islink(fullname):
                    self.stack.append(fullname)
                return fullname
    #</methodize4xi>
#</class4xi>

     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   reviewing all tests
#">                           
# -------------------------------------------------------------------------------------------------
def main():
    global ack2message4index
    global AlphaKB4Xi
    global keys2AlphaKB4Xi
    global key2AlphaKB4Xi

    global IndexKB4Xi
    global keys2IndexKB4Xi
    global key2IndexKB4Xi
    
    global LevelOneKB4Xi
    global keys2LevelOneKB4Xi
    global key2LevelOneKB4Xi
    
    global LevelTwoKB4Xi
    global keys2LevelTwoKB4Xi
    global key2LevelTwoKB4Xi
    
    global LevelThreeKB4Xi
    global keys2LevelThreeKB4Xi
    global key2LevelThreeKB4Xi
    
    global LevelFourKB4Xi
    global keys2LevelFourKB4Xi
    global key2LevelFourKB4Xi
    
    global LevelFiveKB4Xi
    global keys2LevelFiveKB4Xi
    global key2LevelFiveKB4Xi
    
    global LevelSixKB4Xi
    global keys2LevelSixKB4Xi
    global key2LevelSixKB4Xi
    
    global LevelSevenKB4Xi
    global keys2LevelSevenKB4Xi
    global key2LevelSevenKB4Xi
    
    global LevelEightKB4Xi
    global keys2LevelEightKB4Xi
    global key2LevelEightKB4Xi    
            
    global NameKB4Xi
    global keys2NameKB4Xi
    global key2NameKB4Xi
        
    global path2read4xi
    global path2temp4xi

    global t2xi
    global trace_object_count    

       
                       
    # ------------------------------------------------------------------------------------------------- 
    # INITIALIZE
    # -------------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    print("(Step 1A/33) OF MAIN ADD2INDEX4GIMBAL - SET T2XI TO: ", t2xi)
    # <print4xi.Print4Xi object at 0x02388AF0> 

    set2trace4fecth()                                                                                               # trace all classes and functions in the system
    deny2trace4fetch()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                               # tailor trace for this test    

    pipe2fetch = Pipe4Xi()
    queue2fetch = Queue4Xi()
    
       
    # --------------------------------------------------------------------------------------------- 
    # START
    # ---------------------------------------------------------------------------------------------        
    print('=' *70)
    print("(Step 2A/33) OF MAIN ADD2INDEX4GIMBAL - VERSION 3.29.2019 FOR ", path2read4xi, " STARTED ", time4xi())
    # VERSION 3.29.2019 FOR  E://dragonxi//pc4xi//gimbal//  STARTED  10:28:26 03/29/19 FLE Standard Time  
    
    path2read4xi = VersionKB4Xi['folder2add4index']
    print ('(Step 2B/33) OF MAIN ADD2INDEX4GIMBAL - PATH2READ4XI: ', path2read4xi)
    # PATH2READ4XI:  E://dragonxi//pc4xi//gimbal// 
    
    print('=' *70)    
   
    pipe2fetch = Pipe4Xi()
    print("(Step 2C/33) OF MAIN ADD2INDEX4GIMBAL - PIPE2FETCH ", pipe2fetch)    
    # (<pipeconnection4xi.PipeConnection4Xi object at 0x02A04070>, <pipeconnection4xi.PipeConnection4Xi object at 0x02A43C90>) 
    
    queue2fetch = Queue4Xi()
    print("(Step 2D/33) OF MAIN ADD2INDEX4GIMBAL - QUEUE2FETCH ", queue2fetch)    
    # <queue4xi.Queue4Xi object at 0x02A04DB0>
    
    ack2names = False
    
    for file2walk in DirectoryWalker(path2read4xi):
        # ----------------------------------------------------------------------------------------- 
        #
        # -----------------------------------------------------------------------------------------     
        if os.path.isdir(file2walk):
            print ("(Step 3A/33) OF MAIN ADD2INDEX4GIMBAL - DIRECTORY: " + file2walk + '\n')
            # E://dragonxi//pc4xi//gimbal//css
            # E://dragonxi//pc4xi//gimbal//design
            # ...
            
            
            ack2index = True
            
            if ack2index is True:
                try:
                    print ("(Step 3B/33) OF MAIN ADD2INDEX4GIMBAL - STARTING TO WRITE INDEX.HTML IN DIRECTORY: " + file2walk + '\n')
                    # E://dragonxi//pc4xi//gimbal//css
                    # E://dragonxi//pc4xi//gimbal//design
                    # ... 
                    
                    path2write4file = file2walk + "//" + "index.html"  
                    print('(Step 3C/33) OF MAIN ADD2INDEX4GIMBAL - PATH2WRITE4FILE: ', path2write4file)
                    # E://dragonxi//pc4xi//gimbal//design//index.html
                    # ..
        
                    file2output = open(path2write4file,'w')
                    print('(Step 3D/33) OF MAIN ADD2INDEX4GIMBAL - OPENED FILE2OUTPUT: ', file2output)
                    # <_io.TextIOWrapper name='E://dragonxi//pc4xi//gimbal//design//index.html' mode='w' encoding='cp1252'>
                    
                    # 
                    line2write = '<html>' + '\n'  
                    file2output.write(line2write)
                                                   
                    # 
                    line2write = '<head>' + '\n'  
                    file2output.write(line2write)
                    
                    # 
                    line2write = '<title>Gimbal | DragonXi | UAS | Unmanned | Autonomous | </title>' + '\n'  
                    file2output.write(line2write)
                    
                    # 
                    line2write = '</head>' + '\n'  
                    file2output.write(line2write)
                    
                    # 
                    line2write = '<body bgcolor="#000000" text="#555555">' + '\n'  
                    file2output.write(line2write)
                                                   
                    # 
                    line2write = '<script Language="JavaScript">' + '\n'  
                    file2output.write(line2write)
                    
                    # 
                    line2write = 'location.href= ("https://www.gimbal.app");' + '\n'  
                    file2output.write(line2write)
                    
                    # 
                    line2write = '</script>' + '\n'  
                    file2output.write(line2write)
                    
                    # 
                    line2write = 'If gimbal.app does not load click <a href="https://www.gimbal.app">here</a>.' + '\n'  
                    file2output.write(line2write)
                                                   
                    # 
                    line2write = '</body>' + '\n'  
                    file2output.write(line2write)
                    
                    # 
                    line2write = '</html>' + '\n'  
                    file2output.write(line2write)                                   
                                   
           
                    file2output.close()
                    print('(Step 3F/33) OF MAIN ADD2INDEX4GIMBAL - CLOSED FILE2OUTPUT: ', file2output)
                    # 
                except:
                    print ("(Step 3Z/33) OF MAIN ADD2INDEX4GIMBAL - FAILED WRITING INDEX.HTML IN DIRECTORY: " + file2walk + '\n')
                    #                     
            else:
                if ack2message4index is False:
                    print ("(Step 3X/33) OF MAIN ADD2INDEX4GIMBAL - SKIPPED WRITING INDEX.HTML IN DIRECTORY, ACK2INDEX: ", ack2index)
                    #
                    ack2message4index = True     
                else:
                    pass
                    
            ack2names = False
            if ack2names is True:
                # print ("(Step 4A/33) OF MAIN ADD2INDEX4GIMBAL - STARTING TO UPDATE NameKB4Xi ", time4xi()) 
                try:    
                    NameKB4Xi[key2NameKB4Xi] = file2walk
                    print ("NameKB4Xi[", key2NameKB4Xi, "]: ", NameKB4Xi[key2NameKB4Xi])
                    # ...
                    key2NameKB4Xi = key2NameKB4Xi + 1
                except:
                    print ("(Step 4Z/33) OF MAIN ADD2INDEX4GIMBAL - FAILED UPDATING NameKB4Xi WITH FILE2WALK: " + file2walk + '\n')     
            else:
                print ("(Step 4X/33) OF MAIN ADD2INDEX4GIMBAL - SKIPPED UPDATING NameKB4Xi, ACK2NAMES: ", ack2names)     
                
                
    if ack2names is True: 
        print ("(Step 5A/33) OF MAIN ADD2INDEX4GIMBAL - TRYING TO PRINT NameKB4Xi", time4xi())
        # 
        len2cut = len(path2read4xi)
        keys2NameKB4Xi = NameKB4Xi.keys()
        for key2NameKB4Xi in sorted(keys2NameKB4Xi):
            name2optimize = NameKB4Xi[key2NameKB4Xi]
            shortcut2level = name2optimize[len2cut:]
            print ("(Step 5B/33) OF MAIN ADD2INDEX4GIMBAL - SHORTCUT2LEVEL: ", shortcut2level)
            # 
            len2shortcut = len(shortcut2level)
            if len2shortcut == 1:
                try:
                    # a ... z                             <-- Level One consists of alphabetic folders
                    if shortcut2level in keys2AlphaKB4Xi:
                        LevelOneKB4Xi[shortcut2level] = shortcut2level
                    else:
                        print ("(Step 5Z2/33) OF MAIN ADD2INDEX4GIMBAL ** WARNING - SHORTCUT2LEVEL: ", shortcut2level, " NOT IN keys2AlphaKB4Xi: ", keys2AlphaKB4Xi)
                except:
                    print ("(Step 5Z3/33) OF MAIN ADD2INDEX4GIMBAL *** FAILED - SHORTCUT2LEVEL: ", shortcut2level)            
            else:
                # 
                string2search = '\\'
                shortcut2level = shortcut2level[2:]
                # 
                
                index2level=str.find(shortcut2level,string2search)
                if index2level == -1:
                    # 
                    LevelTwoKB4Xi[key2LevelTwoKB4Xi] = shortcut2level
                    key2LevelTwoKB4Xi = key2LevelTwoKB4Xi + 1
                else:
                    # 
                    shortcut2level = shortcut2level[index2level+1:]
                    # 
                    index2level=str.find(shortcut2level,string2search)
                    if index2level == -1:
                        LevelThreeKB4Xi[key2LevelThreeKB4Xi] = shortcut2level
                        # 
                        key2LevelThreeKB4Xi = key2LevelThreeKB4Xi + 1
                    else:
                        shortcut2level = shortcut2level[index2level+1:]
                        index2level=str.find(shortcut2level,string2search)
                        if index2level == -1:
                            LevelFourKB4Xi[key2LevelFourKB4Xi] = shortcut2level
                            key2LevelFourKB4Xi = key2LevelFourKB4Xi + 1
                        else:
                            shortcut2level = shortcut2level[index2level+1:]
                            index2level=str.find(shortcut2level,string2search)
                            if index2level == -1:
                                LevelFiveKB4Xi[key2LevelFiveKB4Xi] = shortcut2level
                                key2LevelFiveKB4Xi = key2LevelFiveKB4Xi + 1
                            else:                                 
                                shortcut2level = shortcut2level[index2level+1:]
                                index2level=str.find(shortcut2level,string2search)
                                if index2level == -1:
                                    LevelSixKB4Xi[key2LevelSixKB4Xi] = shortcut2level
                                    key2LevelSixKB4Xi = key2LevelSixKB4Xi + 1
                                else:
                                    shortcut2level = shortcut2level[index2level+1:]
                                    index2level=str.find(shortcut2level,string2search)
                                    if index2level == -1:
                                        LevelSevenKB4Xi[key2LevelSevenKB4Xi] = shortcut2level
                                        key2LevelSevenKB4Xi = key2LevelSevenKB4Xi + 1
                                    else:
                                        shortcut2level = shortcut2level[index2level+1:]
                                        index2level=str.find(shortcut2level,string2search)
                                        if index2level == -1:
                                            LevelEightKB4Xi[key2LevelEightKB4Xi] = shortcut2level
                                            key2LevelEightKB4Xi = key2LevelEightKB4Xi + 1
                                        else:
                                            print ("(Step 5Z4/33) OF MAIN ADD2INDEX4GIMBAL ** WARNING - SHORTCUT2LEVEL: ", shortcut2level, " SHORTCUT2NAME: ", shortcut2level)
                                pass                                                      
                            pass 
        print ("(Step 5B/33) OF MAIN ADD2INDEX4GIMBAL - TRYING TO PRINT LevelOneKB4Xi ", time4xi())
        #        
        keys2LevelOneKB4Xi = LevelOneKB4Xi.keys()
        for key2LevelOneKB4Xi in sorted(keys2LevelOneKB4Xi):
            print (LevelOneKB4Xi[key2LevelOneKB4Xi])      
            # a ... z
                
        print ("(Step 5C/33) OF MAIN ADD2INDEX4GIMBAL - TRYING TO PRINT LevelTwoKB4Xi ", time4xi())       
        keys2LevelTwoKB4Xi = LevelTwoKB4Xi.keys()
        for key2LevelTwoKB4Xi in sorted(keys2LevelTwoKB4Xi):
            print (LevelTwoKB4Xi[key2LevelTwoKB4Xi])
            # 
            
            
        print ("(Step 5D/33) OF MAIN ADD2INDEX4GIMBAL - TRYING TO PRINT LevelThreeKB4Xi ", time4xi())       
        keys2LevelThreeKB4Xi = LevelThreeKB4Xi.keys()
        for key2LevelThreeKB4Xi in sorted(keys2LevelThreeKB4Xi):
            print (LevelThreeKB4Xi[key2LevelThreeKB4Xi])    
            # 
            
        print ("(Step 5E/33) OF MAIN ADD2INDEX4GIMBAL - TRYING TO PRINT LevelFourKB4Xi ", time4xi())       
        keys2LevelFourKB4Xi = LevelFourKB4Xi.keys()
        for key2LevelFourKB4Xi in sorted(keys2LevelFourKB4Xi):
            print (LevelFourKB4Xi[key2LevelFourKB4Xi]) 
                                                   
        print ("(Step 5F/33) OF MAIN ADD2INDEX4GIMBAL - TRYING TO PRINT LevelFiveKB4Xi ", time4xi())       
        keys2LevelFiveKB4Xi = LevelFiveKB4Xi.keys()
        for key2LevelFiveKB4Xi in sorted(keys2LevelFiveKB4Xi):
            print (LevelFiveKB4Xi[key2LevelFiveKB4Xi])                                                    

        print ("(Step 5G/33) OF MAIN ADD2INDEX4GIMBAL - TRYING TO PRINT LevelSixKB4Xi ", time4xi())       
        keys2LevelSixKB4Xi = LevelSixKB4Xi.keys()
        for key2LevelSixKB4Xi in sorted(keys2LevelSixKB4Xi):
            print (LevelSixKB4Xi[key2LevelSixKB4Xi])    

        print ("(Step 5H/33) OF MAIN ADD2INDEX4GIMBAL - TRYING TO PRINT LevelSevenKB4Xi ", time4xi())       
        keys2LevelSevenKB4Xi = LevelSevenKB4Xi.keys()
        for key2LevelSevenKB4Xi in sorted(keys2LevelSevenKB4Xi):
            print (LevelSevenKB4Xi[key2LevelSevenKB4Xi])                                                                
            
        print ("(Step 5I/33) OF MAIN ADD2INDEX4GIMBAL - TRYING TO PRINT LevelEightKB4Xi ", time4xi())       
        keys2LevelEightKB4Xi = LevelEightKB4Xi.keys()
        for key2LevelEightKB4Xi in sorted(keys2LevelEightKB4Xi):
            print (LevelEightKB4Xi[key2LevelEightKB4Xi])    

            
                                
    # --------------------------------------------------------------------------------------------- 
    # END
    # --------------------------------------------------------------------------------------------- 
    print('=' *75)
    print("(Step 4A/33) OF MAIN ADD2INDEX4GIMBAL - VERSION 9.12.2014 FOR ", path2read4xi, " COMPLETED  ", time4xi())
    # VERSION 9.12.2014 FOR  E://dragonxi//pc4xi//gimbal//  COMPLETED   10:28:26 03/29/19 FLE Standard Time
    
    # ---------------------------------------------------------------------------------------------    
    # Print Trace
    # ---------------------------------------------------------------------------------------------     
    print ('(Step 33A/33) OF MAIN ADD2INDEX4GIMBAL - PRINTING TRACE WITH T2XI', t2xi)
    # <print4xi.Print4Xi object at 0x02388AF0>
    
    print_trace4xi(t2xi)        
    print ('(Step 33B/33) OF MAIN ADD2INDEX4GIMBAL - PRINTED TRACE WITH T2XI', t2xi)           
    # <print4xi.Print4Xi object at 0x02388AF0>
    
#</function4xi>
    
        
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()        
#</program4xi>


# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# 
# 
#"
#>
#     
# 
# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of add2index4gimbal.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>

